/*!
 * @file		NListCtrl.h
 * @brief		/׷ ȭڿ  Ʈ Ʈ(ַ UI)
 * @author		Jinwoo.Lee(jinwoo.lee@nhn.com)
 * @date		2012-04-09 
 * @warning
 * @attention	Copyright 2012 NTS Corp. All rights reserved.
 */
#pragma once

#include "LayeredDlg.h"
#define COLOR_NORMAL_TEXT		(RGB(34, 34, 34))		// #222222
#define COLOR_NORMAL_BK			(RGB(255, 255, 255))
#define COLOR_SELECTED_TEXT		(RGB(34, 34, 34))		// #222222
#define COLOR_SELECTED_BK		(RGB(220, 236, 245))	// #dcecf5
#define COLOR_LINK_NORMAL_TEXT	(RGB(0, 0, 255))
#define COLOR_LINK_HOVER_TEXT	(RGB(255, 0, 0))
#define COLOR_LIST_BORDER		(RGB(220,220,220))		// #dcdcdc

#define UM_GETBUDDY_STATUS		WM_USER + 2039

class CNListCtrl : public CListCtrl
{
	enum eCheckStatus
	{
		CHECK_OFF = 0,
		CHECK_ON
	};

	struct HOVER_ITEM
	{
		int     iItem;
		int     iSubItem;

		HOVER_ITEM()
		{
			iItem = -1;
			iSubItem = 0;
		}
	};

public:
	CNListCtrl(void);
	~CNListCtrl(void);

	void	SetMinColumnWidth(int nWidth);
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	int		GetItemImage(int nItem, int nSubItem);
	BOOL	SetItemImage(int nItem, int nSubItem, int nImage);
	int		GetOnlineUserCount(bool bAllUser);
	int		GetColumnCount();
	void	SetRowHeight(int nRowHeight);			// Fontũ⸦ ؼ ̸ Ѵ.   SetFont ȣϿ  µ Ʈ  ־ .
	void	SetTextFont(CFont* pFont, BOOL bRedraw = TRUE);
	void	SetNormalTextColor(COLORREF crNormalText, COLORREF crNormalBk);
	void	SetSelectedTextColor(COLORREF crSelectedText, COLORREF crSelectedBk);
	void	SetImageColumn(int nImageColumn);		// ̹ µ ÷ (0 )
	BOOL	SetIPTPresenceColumn(int nColumn);		// IPT presence ̹ µ ÷ (0 )
	BOOL	SetWorkStatusColumn(int nColumn);		// WorkStatus ̹ µ ÷ (0 )
	void	ShowEmptyText(BOOL bShow);
	BOOL	SelectAll();
	BOOL	AddCheckBoxForHeadCtrl();

	void	SetFreezeColumns(std::list<int> freezeColList);	// ʺ    ÷ 
	void	SetExternalLinkTextColor(COLORREF crNormal, COLORREF crHover);
	void	SetExternalLinkColumns(std::list<int> linkColList);
	void	ResetHoverStatus();
	void	SetIPTPresenceImageList(CImageList* pilIPTPresence);
	void	SetWorkStatusImageList(CImageList* pilWorkStatus); 
	//bool    IsOffline(int iIndex);
protected:
	DECLARE_MESSAGE_MAP()
	afx_msg void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	afx_msg void OnNMCustomdraw(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnPaint();
	afx_msg void OnHdnBegintrack(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnHotTrack(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnHdnDividerdblclick(NMHDR *pNMHDR, LRESULT *pResult);
	LRESULT OnSetColumnWidth(WPARAM wParam, LPARAM lParam);
protected:
    int			m_nImageColumn;
private:
	void	DrawSubItem(int nItem, int nSubItem, CDC *pDC);
	void	GetDrawColors(int nItem, int nSubItem, COLORREF& colorText, COLORREF& colorBkgnd);
	bool	IsExternalLinkColumn(int nCol);
	void	GetWorkStatusBox(int nCol, CRect& rcBox);
	COLORREF	m_crNormalText;		// ⺻ ڻ
	COLORREF	m_crNormalBk;		// ⺻ 
	COLORREF	m_crSelectedText;	//  ڻ
	COLORREF	m_crSelectedBk;		//  
	COLORREF	m_crLinkNormal;		// ܺ  ڻ
	COLORREF	m_crLinkHover;		// ܺ  ڻ(Mouse hover)

	CFont		m_fontText;
	int			m_nIPTPresenceColumn;
	int			m_nWorkStatusColum;
	CImageList	m_checkBtnImageList;
	BOOL		m_bCheckBoxHead;
	CImageList*	m_pilIPTPresence;
	CImageList* m_pilWorkStatus;
	BOOL		m_bShowEmptyText;
	HOVER_ITEM	m_hoverItem;			//  콺 ö ִ 
	std::list<int>	m_freezeColList;	//    ÷
	std::list<int>	m_linkColList;		// Ŭ ܺη ǰų  ʿ ÷
	int			m_nCursor;
	CLayeredDlg*	m_pWorkStatusLayerDlg;
	void ShowWorkStatusPopup(int nIndex);
	void HideWorkStatusPopup();
	int m_nPrevIndex;
	int m_nMinColumnWidth;

public:
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
};
